import type { EditorState } from '@codemirror/state';
import { Facet } from '@codemirror/state';
import type { Completion, CompletionSource } from './completion.js';
export interface CompletionConfig {
    activateOnTyping?: boolean;
    selectOnOpen?: boolean;
    override?: readonly CompletionSource[] | null;
    closeOnBlur?: boolean;
    maxRenderedOptions?: number;
    defaultKeymap?: boolean;
    aboveCursor?: boolean;
    optionClass?: (completion: Completion) => string;
    icons?: boolean;
    addToOptions?: {
        render: (completion: Completion, state: EditorState) => Node | null;
        position: number;
    }[];
    compareCompletions?: (a: Completion, b: Completion) => number;
    interactionDelay?: number;
}
export declare const completionConfig: Facet<CompletionConfig, Required<CompletionConfig>>;
//# sourceMappingURL=config.d.ts.map