function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e2) { throw _e2; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e3) { didErr = true; err = _e3; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/* eslint-disable no-unused-vars */
/* eslint-disable prefer-const */
import { codePointAt, codePointSize, fromCodePoint } from '@codemirror/state';

// Scores are counted from 0 (great match) down to negative numbers,
// assigning specific penalty values for specific shortcomings.
var Penalty = /*#__PURE__*/function (Penalty) {
  Penalty[Penalty["Gap"] = -1100] = "Gap";
  // Added for each gap in the match (not counted for by-word matches)
  Penalty[Penalty["NotStart"] = -700] = "NotStart";
  // The match doesn't start at the start of the word
  Penalty[Penalty["CaseFold"] = -200] = "CaseFold";
  // At least one character needed to be case-folded to match
  Penalty[Penalty["ByWord"] = -100] = "ByWord";
  return Penalty;
}(Penalty || {}); // The match is by-word, meaning each char in the pattern matches the start of a word in the string
var Tp = /*#__PURE__*/function (Tp) {
  Tp[Tp["NonWord"] = 0] = "NonWord";
  Tp[Tp["Upper"] = 1] = "Upper";
  Tp[Tp["Lower"] = 2] = "Lower";
  return Tp;
}(Tp || {}); // A pattern matcher for fuzzy completion matching. Create an instance
// once for a pattern, and then use that to match any number of
// completions.
export var FuzzyMatcher = /*#__PURE__*/function () {
  function FuzzyMatcher(pattern) {
    _classCallCheck(this, FuzzyMatcher);
    this.pattern = pattern;
    this.chars = [];
    this.folded = [];
    // Buffers reused by calls to `match` to track matched character
    // positions.
    this.any = [];
    this.precise = [];
    this.byWord = [];
    for (var p = 0; p < pattern.length;) {
      var char = codePointAt(pattern, p),
        size = codePointSize(char);
      this.chars.push(char);
      var part = pattern.slice(p, p + size),
        upper = part.toUpperCase();
      this.folded.push(codePointAt(upper === part ? part.toLowerCase() : upper, 0));
      p += size;
    }
    this.astral = pattern.length !== this.chars.length;
  }

  // Matches a given word (completion) against the pattern (input).
  // Will return null for no match, and otherwise an array that starts
  // with the match score, followed by any number of `from, to` pairs
  // indicating the matched parts of `word`.
  //
  // The score is a number that is more negative the worse the match
  // is. See `Penalty` above.
  _createClass(FuzzyMatcher, [{
    key: "match",
    value: function match(word) {
      if (this.pattern.length === 0) {
        return [0];
      }
      if (word.length < this.pattern.length) {
        return null;
      }
      var chars = this.chars,
        folded = this.folded,
        any = this.any,
        precise = this.precise,
        byWord = this.byWord;
      // For single-character queries, only match when they occur right
      // at the start
      if (chars.length === 1) {
        var first = codePointAt(word, 0);
        return first === chars[0] ? [0, 0, codePointSize(first)] : first === folded[0] ? [Penalty.CaseFold, 0, codePointSize(first)] : null;
      }
      var direct = word.indexOf(this.pattern);
      if (direct === 0) {
        return [0, 0, this.pattern.length];
      }
      var len = chars.length,
        anyTo = 0;
      if (direct < 0) {
        for (var i = 0, e = Math.min(word.length, 200); i < e && anyTo < len;) {
          var next = codePointAt(word, i);
          if (next === chars[anyTo] || next === folded[anyTo]) {
            any[anyTo++] = i;
          }
          i += codePointSize(next);
        }
        // No match, exit immediately
        if (anyTo < len) {
          return null;
        }
      }

      // This tracks the extent of the precise (non-folded, not
      // necessarily adjacent) match
      var preciseTo = 0;
      // Tracks whether there is a match that hits only characters that
      // appear to be starting words. `byWordFolded` is set to true when
      // a case folded character is encountered in such a match
      var byWordTo = 0,
        byWordFolded = false;
      // If we've found a partial adjacent match, these track its state
      var adjacentTo = 0,
        adjacentStart = -1,
        adjacentEnd = -1;
      var hasLower = /[a-z]/.test(word),
        wordAdjacent = true;
      // Go over the option's text, scanning for the various kinds of matches
      for (var _i = 0, _e = Math.min(word.length, 200), prevType = Tp.NonWord; _i < _e && byWordTo < len;) {
        var _next = codePointAt(word, _i);
        if (direct < 0) {
          if (preciseTo < len && _next === chars[preciseTo]) {
            precise[preciseTo++] = _i;
          }
          if (adjacentTo < len) {
            if (_next === chars[adjacentTo] || _next === folded[adjacentTo]) {
              if (adjacentTo === 0) {
                adjacentStart = _i;
              }
              adjacentEnd = _i + 1;
              adjacentTo++;
            } else {
              adjacentTo = 0;
            }
          }
        }
        var ch = void 0,
          type = _next < 0xff ? _next >= 48 && _next <= 57 || _next >= 97 && _next <= 122 ? Tp.Lower : _next >= 65 && _next <= 90 ? Tp.Upper : Tp.NonWord : (ch = fromCodePoint(_next)) !== ch.toLowerCase() ? Tp.Upper : ch !== ch.toUpperCase() ? Tp.Lower : Tp.NonWord;
        if (!_i || type === Tp.Upper && hasLower || prevType === Tp.NonWord && type !== Tp.NonWord) {
          if (chars[byWordTo] === _next || folded[byWordTo] === _next && (byWordFolded = true)) {
            byWord[byWordTo++] = _i;
          } else if (byWord.length) {
            wordAdjacent = false;
          }
        }
        prevType = type;
        _i += codePointSize(_next);
      }
      if (byWordTo === len && byWord[0] === 0 && wordAdjacent) {
        return this.result(Penalty.ByWord + (byWordFolded ? Penalty.CaseFold : 0), byWord, word);
      }
      if (adjacentTo === len && adjacentStart === 0) {
        return [Penalty.CaseFold - word.length, 0, adjacentEnd];
      }
      if (direct > -1) {
        return [Penalty.NotStart - word.length, direct, direct + this.pattern.length];
      }
      if (adjacentTo === len) {
        return [Penalty.CaseFold + Penalty.NotStart - word.length, adjacentStart, adjacentEnd];
      }
      if (byWordTo === len) {
        return this.result(Penalty.ByWord + (byWordFolded ? Penalty.CaseFold : 0) + Penalty.NotStart + (wordAdjacent ? 0 : Penalty.Gap), byWord, word);
      }
      return chars.length === 2 ? null : this.result((any[0] ? Penalty.NotStart : 0) + Penalty.CaseFold + Penalty.Gap, any, word);
    }
  }, {
    key: "result",
    value: function result(score, positions, word) {
      var result = [score - word.length],
        i = 1;
      var _iterator = _createForOfIteratorHelper(positions),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var pos = _step.value;
          var to = pos + (this.astral ? codePointSize(codePointAt(word, pos)) : 1);
          if (i > 1 && result[i - 1] === pos) {
            result[i - 1] = to;
          } else {
            result[i++] = pos;
            result[i++] = to;
          }
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
      return result;
    }
  }]);
  return FuzzyMatcher;
}();