import { Emitter } from '@difizen/libro-common/app';
interface DocStatus {
    source: string[];
    cursor: number;
    changes?: string;
}
interface CompletionChange {
    start?: DocStatus;
    accept?: DocStatus;
    close?: DocStatus;
    selectIndex?: number;
}
export declare class CompletionMonitor {
    protected static instance: CompletionMonitor;
    static getInstance(): CompletionMonitor;
    protected completionChangeEmitter: Emitter<CompletionChange>;
    get compeltionChange(): import("@difizen/libro-common/app").Event<CompletionChange>;
    protected tooltipChangeEmitter: Emitter<boolean>;
    get onTooltipChange(): import("@difizen/libro-common/app").Event<boolean>;
    protected currentChange: CompletionChange | undefined;
    start(doc: DocStatus): void;
    accept(doc: DocStatus): void;
    close(doc: DocStatus): void;
    updateIndex(index: number): void;
    emitChange(change: CompletionChange): void;
}
export interface MonitorPluginOptions {
    onTooltipChange?: (visible: boolean) => void;
}
export declare const monitorPlugin: (options: MonitorPluginOptions) => import("@codemirror/state").Extension;
export {};
//# sourceMappingURL=monitor.d.ts.map